import * as React from 'react';
import { LayoutProvider, useLayoutContext } from './LayoutContext';
import { Box, useTheme } from '@mui/material';
import { layoutConfig } from './index';
export var sidebarWith = 220;
export var Layout = function (_a) {
    var sidebar = _a.sidebar, header = _a.header, title = _a.title, mobileBreakpoint = _a.mobileBreakpoint, children = _a.children;
    return (React.createElement(LayoutProvider, { title: title, mobileBreakpoint: mobileBreakpoint, showSidebarButton: !!sidebar },
        React.createElement(LayoutUsingContext, { sidebar: sidebar, header: header }, children)));
};
var LayoutUsingContext = function (_a) {
    var sidebar = _a.sidebar, header = _a.header, children = _a.children;
    var _b = useLayoutContext(), sidebarOpen = _b.sidebarOpen, sidebarPinned = _b.sidebarPinned, isMobileWidth = _b.isMobileWidth;
    var theme = useTheme();
    // TODO Not really safe
    var defaultSpacing = theme.spacing(1).slice(0, -2);
    return (React.createElement(React.Fragment, null,
        header,
        sidebar,
        React.createElement(Box, { component: "main", sx: {
                transition: function (t) { return t.transitions.create('all'); },
                paddingLeft: (sidebar && sidebarOpen && sidebarPinned && !isMobileWidth ? layoutConfig.sidebarWith + defaultSpacing : 0) + 'px',
                overflow: 'hidden',
                position: 'relative',
                display: 'flex',
                flexDirection: 'column',
            } }, children)));
};
