import { Dispatch, ReactNode, SetStateAction } from 'react';
export interface LayoutProviderProps {
    children: ReactNode;
    mobileBreakpoint?: number;
    title?: string;
    showSidebarButton?: boolean;
}
export interface UseLayoutContextProps {
    sidebarOpen: boolean;
    setSidebarOpen: Dispatch<SetStateAction<boolean>>;
    sidebarPinned: boolean;
    setSidebarPinned: Dispatch<SetStateAction<boolean>>;
    title?: string;
    isMobileWidth: boolean;
    showSidebarButton?: boolean;
}
export declare const LayoutProvider: ({ title, showSidebarButton, mobileBreakpoint, children }: LayoutProviderProps) => JSX.Element;
export declare const useLayoutContext: () => UseLayoutContextProps;
