import * as React from 'react';
import { createContext, useContext, useEffect, useState } from 'react';
import { usePersistentState } from 'react-persistent-state';
var LayoutContext = createContext({});
export var LayoutProvider = function (_a) {
    var title = _a.title, showSidebarButton = _a.showSidebarButton, _b = _a.mobileBreakpoint, mobileBreakpoint = _b === void 0 ? 760 : _b, children = _a.children;
    var _c = useState(getWidth()), pageWidth = _c[0], setPageWidth = _c[1];
    var _d = usePersistentState(true, 'sidebarOpen'), sidebarOpen = _d[0], setSidebarOpen = _d[1];
    var _e = usePersistentState(true, 'sidebarPinned'), sidebarPinned = _e[0], setSidebarPinned = _e[1];
    useEffect(function () {
        window.addEventListener('resize', function () { return setPageWidth(getWidth()); });
    }, []);
    return (React.createElement(LayoutContext.Provider, { value: {
            sidebarOpen: sidebarOpen,
            setSidebarOpen: setSidebarOpen,
            sidebarPinned: sidebarPinned,
            setSidebarPinned: setSidebarPinned,
            title: title,
            isMobileWidth: pageWidth < mobileBreakpoint,
            showSidebarButton: showSidebarButton,
        } }, children));
};
function getWidth() {
    return window.outerWidth;
}
export var useLayoutContext = function () {
    return useContext(LayoutContext);
};
