var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { useEffect } from 'react';
import { Box, SwipeableDrawer, Switch } from '@mui/material';
import { useLayoutContext } from '../LayoutContext';
import { layoutConfig } from '../index';
import { SidebarFooter } from './SidebarFooter';
import { SidebarItem } from './SidebarItem';
import { SidebarBody } from './SidebarBody';
import { SidebarHeader } from './SidebarHeader';
import { stopPropagation } from '../../../_utils/common';
var sidebarId = 'mui-sidebar-id';
var sidebar = null;
/**
 * Don't do it the React way to improve perfs
 */
var stickSidebarToHeader = function () {
    if (!sidebar) {
        sidebar = document.getElementById(sidebarId);
    }
    if (sidebar) {
        sidebar.style.top = Math.max(layoutConfig.headerHeight - window.scrollY, 0) + 'px';
    }
};
export var Sidebar = function (_a) {
    var children = _a.children, sx = _a.sx, _b = _a.pinLabel, pinLabel = _b === void 0 ? 'Pin' : _b, props = __rest(_a, ["children", "sx", "pinLabel"]);
    var _c = useLayoutContext(), isMobileWidth = _c.isMobileWidth, sidebarOpen = _c.sidebarOpen, setSidebarOpen = _c.setSidebarOpen, sidebarPinned = _c.sidebarPinned, setSidebarPinned = _c.setSidebarPinned;
    useEffect(function () {
        // Element has been re-created by SwipeableDrawer, thus variable point to nothing.
        sidebar = null;
        stickSidebarToHeader();
        setSidebarOpen(function (_) { return !isMobileWidth; });
    }, [isMobileWidth, sidebarPinned]);
    useEffect(function () {
        window.addEventListener('scroll', stickSidebarToHeader);
    }, []);
    var isTemporary = isMobileWidth || !sidebarPinned;
    return (React.createElement(SwipeableDrawer, { PaperProps: {
            id: sidebarId,
            sx: __assign({ position: 'fixed', border: 'none', bottom: 0, height: 'auto' }, (isTemporary && {
                top: '0 !important',
            })),
        }, open: sidebarOpen, onOpen: function () { return setSidebarOpen(true); }, onClose: function () { return setSidebarOpen(false); }, variant: isTemporary ? 'temporary' : 'persistent' },
        React.createElement(Box, __assign({ sx: __assign({ width: layoutConfig.sidebarWith, height: '100%', transition: function (t) { return t.transitions.create('width'); }, overflowY: 'auto', background: function (t) { return t.palette.background.default; }, display: 'flex', flexDirection: 'column', borderRadius: 0 }, sx) }, props),
            React.createElement(SidebarHeader, { hidden: !isTemporary }),
            React.createElement(SidebarBody, null, children),
            !isMobileWidth && (React.createElement(SidebarFooter, null,
                React.createElement(SidebarItem, { onClick: stopPropagation(function () { return setSidebarPinned(function (_) { return !_; }); }), icon: "push_pin", sx: { mr: 0, pr: 0 } },
                    pinLabel,
                    React.createElement(Switch, { color: "primary", sx: { ml: 'auto' }, checked: sidebarPinned, onChange: function () { return setSidebarPinned(function (_) { return !_; }); } })))))));
};
